#include "tablefield.h"

/*TableField::TableField()
{
}
*/

/***********************************************************************************************
 **   TableField     -  
 **      :
 ** *parent = 0 ( "" )
 ** ftype = CHAR(30) (     -   30 )
 ** fdefaultValue = NULL (     "" )
 ***********************************************************************************************/

TableField::TableField(QString fname, QObject *parent, QString ftype, QString fdefaultValue):
  QObject(parent)
{
    fieldName = fname;
    fieldType = ftype;
    defaultValue = fdefaultValue;
    notNull = false;                    //        ( NULL)
    characterSet = "";                  //    (  )
    createSqlString();                  //   Sql-,       
}



/*******************************************************************
**    name ( ),
**
*******************************************************************/



void TableField::setName(QString name){
    TableField::fieldName = name;
    TableField::createSqlString();
}


QString TableField::name(){
    return TableField::fieldName;
}

QString TableField::type(){
    return TableField::fieldType;
}

void TableField::setType(QString ftype){
TableField::fieldType = ftype;
TableField::createSqlString();
}

/*************************************************************************
**  isNotNull()  true,     "NOT NULL"
**  -  false
*************************************************************************/

bool TableField::isNotNull(){
return TableField::notNull;
}

/*******************************************************************
**     "NOT NULL"
**      
*******************************************************************/


void TableField::setNotNull(bool fnotNull){
    if ((fnotNull) && (defaultValue == "NULL")) defaultValue = ""; //     , ,     NULL,     
    TableField::notNull = fnotNull;
    TableField::createSqlString(); //   Sql-   
}


/********************************************************************************************
**    Sql-,       
**      SqlString
********************************************************************************************/

void TableField::createSqlString(){
QString str_tmp = "";
str_tmp.append(tr("'"));
str_tmp.append(fieldName);
str_tmp.append(tr("' "));
str_tmp.append(fieldType);
//str_tmp.append(tr(" "));
if (characterSet !="") {
str_tmp.append(tr(" character set"));
str_tmp.append(characterSet);
}
if (notNull) { str_tmp.append(tr(" NOT NULL")); }
if (defaultValue !="") {
    str_tmp.append(tr(" default '"));
    str_tmp.append(defaultValue);
    str_tmp.append(tr("'"));}

TableField::SqlString = str_tmp;
}


QString TableField::sqlString(){
return TableField::SqlString;
}


void TableField::setDefaultValue(QString fdefaultValue){
 TableField::defaultValue = fdefaultValue;
 TableField::createSqlString();
}

